/*
 * @(#)DefaultProblemManagerInfoUTest.java
 *
 * Copyright (C) 2002-2003 Matt Albrecht
 * groboclown@users.sourceforge.net
 * http://groboutils.sourceforge.net
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a
 *  copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 *  the rights to use, copy, modify, merge, publish, distribute, sublicense,
 *  and/or sell copies of the Software, and to permit persons to whom the
 *  Software is furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 *  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 *  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 *  DEALINGS IN THE SOFTWARE.
 */

package net.sourceforge.groboutils.pmti.v1.defimpl;

import net.sourceforge.groboutils.pmti.v1.*;

import org.easymock.EasyMock;
import org.easymock.MockControl;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import net.sourceforge.groboutils.autodoc.v1.*;
import net.sourceforge.groboutils.junit.v1.iftc.*;
import junit.framework.AssertionFailedError;


/**
 * Tests the DefaultProblemManagerInfo class.
 *
 * @author    Matt Albrecht <a href="mailto:groboclown@users.sourceforge.net">groboclown@users.sourceforge.net</a>
 * @version   $Date: 2003/05/29 13:05:49 $
 * @since     July 20, 2002
 */
public class DefaultProblemManagerInfoUTest extends TestCase
{
    //-------------------------------------------------------------------------
    // Standard JUnit Class-specific declarations
    
    private static final Class THIS_CLASS = DefaultProblemManagerInfoUTest.class;
    private static final AutoDoc DOC = new AutoDoc( THIS_CLASS );
    
    public DefaultProblemManagerInfoUTest( String name )
    {
        super( name );
    }

    
    //-------------------------------------------------------------------------
    // setup
    
    /**
     * 
     * @exception Exception thrown under any exceptional condition.
     */
    protected void setUp() throws Exception
    {
        super.setUp();
        
        // set ourself up
    }


    //-------------------------------------------------------------------------
    // Tests
    
    
    public void testConstructor1()
    {
        try
        {
            new DefaultProblemManagerInfo( null, null );
        }
        catch (IllegalArgumentException iae)
        {
            // test exception ???
        }
    }
    
    
    public void testConstructor2()
    {
        try
        {
            new DefaultProblemManagerInfo( "a", null );
        }
        catch (IllegalArgumentException iae)
        {
            // test exception ???
        }
    }
    
    
    public void testConstructor3()
    {
        IAttributeInfo[] at = {};
        IIssueTypeInfo[] iti = {
                new DefaultIssueTypeInfo( "1", at, null, null, null ),
            };
        try
        {
            new DefaultProblemManagerInfo( null, iti );
        }
        catch (IllegalArgumentException iae)
        {
            // test exception ???
        }
    }
    
    
    public void testConstructor4()
    {
        IAttributeInfo[] at = {};
        IIssueTypeInfo[] iti = {
                new DefaultIssueTypeInfo( "1", at, null, null, null ),
            };
        try
        {
            new DefaultProblemManagerInfo( "2", iti );
        }
        catch (IllegalArgumentException iae)
        {
            // test exception ???
        }
    }
    
    
    public void testConstructor5()
    {
        IAttributeInfo[] at = {};
        IIssueTypeInfo[] iti = {
                new DefaultIssueTypeInfo( "1", at, null, null, null ),
            };
        new DefaultProblemManagerInfo( "1", iti );
    }
    
    
    public void testConstructor6()
    {
        IAttributeInfo[] at = {};
        IIssueTypeInfo[] iti = {
                new DefaultIssueTypeInfo( "2", at, null, null, null ),
                new DefaultIssueTypeInfo( "3", at, null, null, null ),
                new DefaultIssueTypeInfo( "1", at, null, null, null ),
            };
        new DefaultProblemManagerInfo( "1", iti );
    }
    
    
    public void testConstructor7()
    {
        IAttributeInfo[] at = {};
        IIssueTypeInfo[] iti = {
                new DefaultIssueTypeInfo( "2", at, null, null, null ),
                new DefaultIssueTypeInfo( "3", at, null, null, null ),
                new DefaultIssueTypeInfo( "1", at, null, null, null ),
                new DefaultIssueTypeInfo( "2", at, null, null, null ),
            };
        new DefaultProblemManagerInfo( "1", iti );
    }
    
    
    
    //-------------------------------------------------------------------------
    // Helpers
    
    
    //-------------------------------------------------------------------------
    // Standard JUnit declarations
    
    
    public static Test suite()
    {
        InterfaceTestSuite suite = IProblemManagerInfoUTestI.suite();
        suite.addTestSuite( THIS_CLASS );
        suite.addFactory( new CxFactory( "A" ) {
            public Object createImplObject() {
                IAttributeInfo[] at = {};
                IIssueTypeInfo[] iti = {
                        new DefaultIssueTypeInfo( "1", at, null, null, null ),
                    };
                return new DefaultProblemManagerInfo( "1", iti );
            }
        } );
        
        return suite;
    }
    
    public static void main( String[] args )
    {
        String[] name = { THIS_CLASS.getName() };
        
        // junit.textui.TestRunner.main( name );
        // junit.swingui.TestRunner.main( name );
        
        junit.textui.TestRunner.main( name );
    }
    
    
    /**
     * 
     * @exception Exception thrown under any exceptional condition.
     */
    protected void tearDown() throws Exception
    {
        // tear ourself down
        
        
        super.tearDown();
    }
}

